#!/bin/sh
#########################################################################################
# This is video card swich tool . Now supports video card switching .			#
# IGD ----->S3G										#
# PEG------>NVIDIA(open deiver or closed  driver)					#
# PEG------>ATI (open deiver)								#
#########################################################################################
nvidia=`lspci | grep -i vga | grep -i NVIDIA` 
ati=`lspci | grep -i VGA | grep -i ATI`
s3g=`lspci | grep -i VGA | grep -i VIA`

#NVIDIA_NAME=`dpkg -l | grep nvidia  | grep "binary" | awk '{print $2}'`
#S3G_NAME=`dpkg -l | grep xserver-xorg-video-s3g | awk '{print$2}'`
#ATI_NAME=`dpkg -l | grep xserver-xorg-video-ati | awk '{print$2}'`

NVIDIA_NAME=$(dpkg -l | grep nvidia  | grep "binary" | awk '{print $2}')
S3G_NAME=$(dpkg -l | grep xserver-xorg-video-s3g | awk '{print$2}')
ATI_NAME=$(dpkg -l | grep xserver-xorg-video-ati | awk '{print$2}')

LOG_VIDEO_SWITCH="/var/log/video-switch.log"

mdm_restart ()
{
	/etc/init.d/mdm restart
	echo "first restart for detect card" >> $LOG_VIDEO_SWITCH
}


open_config ()
{
	echo "Into open driver!!!" >> $LOG_VIDEO_SWITCH
	LIBGX_S3G_OPEN=$(cat /etc/ld.so.conf.d/i386-linux-gnu_GL.conf | awk -F"/" '{print $NF}')
	if [ "${LIBGX_S3G_OPEN}" = "mesa" ]; then	
		echo "still  open (mesa)"  >> $LOG_VIDEO_SWITCH	
	else
	#open_config
		if [ -e /etc/ld.so.conf.d/i386-linux-gnu_GL.conf ]; then
			rm -rf /etc/ld.so.conf.d/i386-linux-gnu_GL.conf
			echo "rm -rf /etc/ld.so.conf.d/i386-linux-gnu_GL.conf"	>> $LOG_VIDEO_SWITCH
		fi
		if [ -e /etc/alternatives/glamor_conf ]; then
			rm -f /etc/alternatives/glamor_conf  
		fi

		if [ -e /etc/alternatives/i386-linux-gnu_gl_conf ]; then
			rm -f /etc/alternatives/i386-linux-gnu_gl_conf 
		fi

		if [ -e /etc/alternatives/i386-linux-gnu_xorg_extra_modules ]; then	
			rm -f /etc/alternatives/i386-linux-gnu_xorg_extra_modules
		fi
		if [ -e /etc/alternatives/i386-linux-gnu_grub_fb_blacklist ] ; then
			rm -f /etc/alternatives/i386-linux-gnu_grub_fb_blacklist
		fi
		if [ -e /etc/alternatives/x86_64-linux-gnu_gl_conf ] ; then
			rm -f /etc/alternatives/x86_64-linux-gnu_gl_conf 
		fi
		
		ln -sf /usr/lib/i386-linux-gnu/mesa/ld.so.conf   /etc/alternatives/i386-linux-gnu_gl_conf 
		ln -sf /etc/alternatives/i386-linux-gnu_gl_conf  /etc/ld.so.conf.d/i386-linux-gnu_GL.conf
		ln -sf /usr/lib/i386-linux-gnu/xorg/x11-extra-modules /etc/alternatives/i386-linux-gnu_xorg_extra_modules 

		echo "ln -sf /etc/alternatives/i386-linux-gnu_gl_conf  /etc/ld.so.conf.d/i386-linux-gnu_GL.conf" >> $LOG_VIDEO_SWITCH
		ldconfig
		if which update-grub-gfxpayload >/dev/null 2>&1; then
			update-grub-gfxpayload
		fi
 
		if [ "${LIBGX_S3G}" =  " ${NVIDIA_NAME} " ]; then
			if [ `which quirks-handler` ]; then
				quirks-handler -d $NVIDIA_NAME -v
			fi
		fi

		ldconfig	
		
		mdm_restart
	fi
}

nvidia_config ()
{

	LIBGX_NVIDIA=$(cat /etc/ld.so.conf.d/i386-linux-gnu_GL.conf | awk -F"/" '{print $NF}')
	if [ "${LIBGX_NVIDIA}" = "${NVIDIA_NAME}" ]; then 
		echo "still nvidia" >> $LOG_VIDEO_SWITCH
	else	
	  	echo "first nvidia , switch config nvidia" >> $LOG_VIDEO_SWITCH
		if [ -e /etc/ld.so.conf.d/i386-linux-gnu_GL.conf ]; then
			rm -rf /etc/ld.so.conf.d/i386-linux-gnu_GL.conf
			echo "rm -rf /etc/ld.so.conf.d/i386-linux-gnu_GL.conf "	>> $LOG_VIDEO_SWITCH 
		fi

		ln -s /usr/share/$NVIDIA_NAME/glamor.conf /etc/alternatives/glamor_conf
		if [ -e /etc/alternatives/i386-linux-gnu_gl_conf ]; then
			rm -f /etc/alternatives/i386-linux-gnu_gl_conf
			ln -sf /usr/lib/$NVIDIA_NAME/ld.so.conf /etc/alternatives/i386-linux-gnu_gl_conf 
			ln -sf /etc/alternatives/i386-linux-gnu_gl_conf  /etc/ld.so.conf.d/i386-linux-gnu_GL.conf
			echo "ln -s /usr/lib/$NVIDIA_NAME/ld.so.conf /etc/alternatives/i386-linux-gnu_gl_conf "	>> $LOG_VIDEO_SWITCH 
		fi
 
		ln -sf /usr/share/$NVIDIA_NAME/$NVIDIA_NAME.grub-gfxpayload /etc/alternatives/i386-linux-gnu_grub_fb_blacklist 
		if [ -e /etc/alternatives/i386-linux-gnu_xorg_extra_modules ]; then	
			rm -f /etc/alternatives/i386-linux-gnu_xorg_extra_modules
			ln -sf /usr/lib/$NVIDIA_NAME/xorg /etc/alternatives/i386-linux-gnu_xorg_extra_modules
		fi 

		ln -sf /usr/lib/$NVIDIA_NAME/alt_ld.so.conf /etc/alternatives/x86_64-linux-gnu_gl_conf
		ldconfig

		if which update-grub-gfxpayload >/dev/null 2>&1; then
			update-grub-gfxpayload
		fi 	
	
		if [ `which quirks-handler` ]; then
			quirks-handler -e $NVIDIA_NAME -v
		fi
		ldconfig

		mdm_restart
	fi

}

ati_config ()
{

	LIBGX_ATI=$(cat /etc/ld.so.conf.d/i386-linux-gnu_GL.conf | awk -F"/" '{print $NF}')
	if [ "${LIBGX_ATI}" = "mesa" ]; then	
		echo "still ati"  >> $LOG_VIDEO_SWITCH	
	else
		echo "first ati , switch config ati  " >> $LOG_VIDEO_SWITCH	
		if [ -e /etc/ld.so.conf.d/i386-linux-gnu_GL.conf ]; then
			rm -rf /etc/ld.so.conf.d/i386-linux-gnu_GL.conf
			echo "rm -rf /etc/ld.so.conf.d/i386-linux-gnu_GL.conf"	>> $LOG_VIDEO_SWITCH	 
		fi
		if [ -e /etc/alternatives/glamor_conf ]; then
			rm -f /etc/alternatives/glamor_conf  
		fi

		if [ -e /etc/alternatives/i386-linux-gnu_gl_conf ]; then
			rm -f /etc/alternatives/i386-linux-gnu_gl_conf 
		fi

		if [ -e /etc/alternatives/i386-linux-gnu_xorg_extra_modules ]; then	
			rm -f /etc/alternatives/i386-linux-gnu_xorg_extra_modules
		fi
		if [ -e /etc/alternatives/i386-linux-gnu_grub_fb_blacklist ] ; then
			rm -f /etc/alternatives/i386-linux-gnu_grub_fb_blacklist
		fi
		if [ -e /etc/alternatives/x86_64-linux-gnu_gl_conf ] ; then
			rm -f /etc/alternatives/x86_64-linux-gnu_gl_conf 
		fi

		ln -sf /usr/lib/i386-linux-gnu/mesa/ld.so.conf   /etc/alternatives/i386-linux-gnu_gl_conf 
		ln -sf /etc/alternatives/i386-linux-gnu_gl_conf  /etc/ld.so.conf.d/i386-linux-gnu_GL.conf
		ln -sf /usr/lib/i386-linux-gnu/xorg/x11-extra-modules /etc/alternatives/i386-linux-gnu_xorg_extra_modules 
	
		echo "ln -sf /etc/alternatives/i386-linux-gnu_gl_conf  /etc/ld.so.conf.d/i386-linux-gnu_GL.conf" >> $LOG_VIDEO_SWITCH
		ldconfig
		if which update-grub-gfxpayload >/dev/null 2>&1; then
			update-grub-gfxpayload
		fi
		if [ "${LIBGX_ATI}" =  " ${NVIDIA_NAME} " ]; then
			if [ `which quirks-handler` ]; then
				quirks-handler -d $NVIDIA_NAME -v
			fi
		fi

		ldconfig
	
		mdm_restart
	fi 	

}

s3g_config ()
{
	LIBGX_S3G=$(cat /etc/ld.so.conf.d/i386-linux-gnu_GL.conf | awk -F"/" '{print $NF}')
	if [ "${LIBGX_S3G}" = "s3g" ]; then
		echo "still s3g"  >> $LOG_VIDEO_SWITCH
	else
		echo "first s3g , switch config s3g  " >> $LOG_VIDEO_SWITCH
		if [ -e /etc/alternatives/glamor_conf ]; then
			rm -f /etc/alternatives/glamor_conf  
			echo " rm -f /etc/alternatives/glamor_conf " >> $LOG_VIDEO_SWITCH
		fi

		if [ -e /etc/ld.so.conf.d/i386-linux-gnu_GL.conf ]; then
			rm -f /etc/ld.so.conf.d/i386-linux-gnu_GL.conf 
			echo " rm -f /etc/ld.so.conf.d/i386-linux-gnu_GL.conf  " >> $LOG_VIDEO_SWITCH
		fi

		if [ -e /etc/alternatives/i386-linux-gnu_gl_conf ]; then
			rm -f /etc/alternatives/i386-linux-gnu_gl_conf
			echo "rm -f /etc/alternatives/i386-linux-gnu_gl_conf " >> $LOG_VIDEO_SWITCH
		fi
	
		if [ -e /etc/alternatives/i386-linux-gnu_xorg_extra_modules ]; then	
			rm -f /etc/alternatives/i386-linux-gnu_xorg_extra_modules
		fi

		ln -sf /usr/lib/s3g/ld.so.conf  /etc/alternatives/i386-linux-gnu_gl_conf 
		ln -sf /etc/alternatives/i386-linux-gnu_gl_conf /etc/ld.so.conf.d/i386-linux-gnu_GL.conf
		ln -sf /usr/lib/s3gxorg /etc/alternatives/i386-linux-gnu_xorg_extra_modules

		ldconfig
		#bug
		if which update-grub-gfxpayload >/dev/null 2>&1; then
			update-grub-gfxpayload
		fi

		if [ "${LIBGX_S3G}" =  " ${NVIDIA_NAME} " ]; then
			if [ `which quirks-handler` ]; then
				quirks-handler -d $NVIDIA_NAME -v
			fi
		fi

		ldconfig

		mdm_restart
	fi
		
}

################### main################################
if [ -n "$s3g" ] ;then 
	#s3g card  
	echo "Into s3g card switch!!! =`date` "  >> $LOG_VIDEO_SWITCH
	if [ "${S3G_NAME}" = "xserver-xorg-video-s3g" ]; then
		echo "Do switch s3g config!!!"	>> $LOG_VIDEO_SWITCH		
		s3g_config
	else
		echo "No xserver-xorg-video-s3g driver packet" >> $LOG_VIDEO_SWITCH		
		echo "Config open  driver " >> $LOG_VIDEO_SWITCH
		open_config
	fi

elif [ -n "$nvidia" ]; then  
	#NVIDIA card
	echo "Into Nvidia card switch!!! =`date` "  >> $LOG_VIDEO_SWITCH
	if [ -n "${NVIDIA_NAME}" ]; then #bug
		echo "Do switch nvidia config " >> $LOG_VIDEO_SWITCH
		nvidia_config
	else
		echo "No nvidia driver packet" >> $LOG_VIDEO_SWITCH
		open_config
		echo "Config open  driver " >> $LOG_VIDEO_SWITCH
	fi

elif [ -n "$ATI_NAME" ];then
        #ATI
	echo "Into Ati card switch!!! =`date` "  >> $LOG_VIDEO_SWITCH
	if [ "${ATI_NAME}" = "xserver-xorg-video-ati" ]; then 
		echo "Do switch ati config " >> $LOG_VIDEO_SWITCH	
		ati_config
	else
		echo "No xserver-xorg-video-ati driver packet" >> $LOG_VIDEO_SWITCH
		open_config
		echo "Config open  driver " >> $LOG_VIDEO_SWITCH
	fi
else
       #other
	echo "Not ati nv s3g; doing open_config() :`date`" >> $LOG_VIDEO_SWITCH
	open_config
fi

